"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _util = require("../_util");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _pickerColumn = _interopRequireDefault(require("./picker-column"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _createNamespace = (0, _util.createNamespace)('picker'),
    bem = _createNamespace.bem;

var PickerPortal = /*#__PURE__*/function (_React$Component) {
  _inherits(PickerPortal, _React$Component);

  var _super = _createSuper(PickerPortal);

  function PickerPortal(props) {
    var _this;

    _classCallCheck(this, PickerPortal);

    _this = _super.call(this, props);
    _this.el = document.createElement('div');
    _this.el.className = 'picker-portal';

    _this.__handlePreventDefault__ = function (e) {
      return e.preventDefault();
    };

    _this.pickerRef = _react.default.createRef();
    return _this;
  }

  _createClass(PickerPortal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.el.addEventListener('touchmove', this.__handlePreventDefault__);
      document.body.appendChild(this.el);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.el.removeEventListener('touchmove', this.__handlePreventDefault__);
      document.body.removeChild(this.el);
    }
  }, {
    key: "show",
    value: function show() {
      this.pickerRef.current.show();
    }
  }, {
    key: "hide",
    value: function hide() {
      this.pickerRef.current.hide();
    }
  }, {
    key: "resetField",
    value: function resetField() {
      this.pickerRef.current.resetField();
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0, _reactDom.createPortal)( /*#__PURE__*/_react.default.createElement(Picker, _extends({}, this.props, {
        ref: this.pickerRef
      })), this.el);
    }
  }]);

  return PickerPortal;
}(_react.default.Component);

var Picker = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var cancelBtnText = props.cancelBtnText,
      confirmBtnText = props.confirmBtnText,
      columns = props.columns,
      columnsValue = props.columnsValue,
      visibleItemCount = props.visibleItemCount,
      onCancel = props.onCancel,
      onConfirm = props.onConfirm,
      onChange = props.onChange;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      _showPicker = _useState2[0],
      setShowPicker = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      _showMask = _useState4[0],
      setShowMask = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      _showPanel = _useState6[0],
      setShowPanel = _useState6[1];

  var _useState7 = (0, _react.useState)(0),
      _useState8 = _slicedToArray(_useState7, 2),
      _itemHeight = _useState8[0],
      setItemHeight = _useState8[1];

  var _useState9 = (0, _react.useState)([].concat(columns)),
      _useState10 = _slicedToArray(_useState9, 2),
      _columns = _useState10[0],
      setColumnsData = _useState10[1];

  var _useState11 = (0, _react.useState)([].concat(columnsValue)),
      _useState12 = _slicedToArray(_useState11, 2),
      _columnsValue = _useState12[0],
      setColumnsDataValue = _useState12[1];

  var _useState13 = (0, _react.useState)(new Date().getTime()),
      _useState14 = _slicedToArray(_useState13, 2),
      _timeStamp = _useState14[0],
      setTimeStamp = _useState14[1];

  var baseOffset = _itemHeight * (visibleItemCount - 1) / 2;
  var pickerEl = null;
  var columnsEl = null; // 异步更新

  (0, _react.useEffect)(function () {
    return setColumnsData([].concat(columns));
  }, [columns]); // useEffect(() => {
  //   document.body.appendChild(pickerEl)
  //   return () => document.body.removeChild(pickerEl)
  // }, [])
  // 获取li高度

  (0, _react.useEffect)(function () {
    if (!_itemHeight) {
      var li = columnsEl.querySelector('li');
      if (li) setItemHeight(window.getComputedStyle(li).height.match(/\d*\.?\d*/)[0] * 1 || 44);
    }
  });

  var toShowPicker = function toShowPicker() {
    setShowPicker(true);
    setShowMask(true);
    setShowPanel(true);
  };

  var toHidePicker = function toHidePicker() {
    setShowPicker(false);
    setShowMask(false);
    setShowPanel(false);
  };

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      show: toShowPicker,
      hide: toHidePicker,
      resetField: function resetField() {
        setColumnsData([].concat(columns));
        setTimeStamp(new Date().getTime());
      }
    };
  });
  var handleColumnChange = (0, _react.useCallback)(function (columnIndex, selectedIndex, column) {
    var children = column[selectedIndex].children;

    if (children) {
      _columns[columnIndex + 1] = children;
      setTimeout(function () {
        return setColumnsData([].concat(_columns));
      }, 10);
    }

    _columnsValue[columnIndex] = column[selectedIndex]; // [ {text: "浙江省", value: "330000" }, { text: "绍兴市", value: "330600"}, { text: "上虞区", value: "330604" }]

    onChange(_columnsValue);
  }, [_columns]);

  var handleCancelClick = function handleCancelClick(e) {
    onCancel(_columnsValue);
    toHidePicker();
  };

  var handleConfirmClick = function handleConfirmClick(e) {
    onConfirm(_columnsValue);
    toHidePicker();
  };

  console.log('picker mounted or update');
  return /*#__PURE__*/_react.default.createElement("div", {
    className: bem({
      show: _showPicker
    }),
    ref: function ref(el) {
      return pickerEl = el;
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: bem('mask', {
      show: _showMask
    })
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: bem('panel', {
      show: _showPanel
    })
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: bem('toolbar')
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: bem('cancel'),
    onClick: handleCancelClick
  }, cancelBtnText ? cancelBtnText : '取消'), /*#__PURE__*/_react.default.createElement("div", {
    className: bem('confirm'),
    onClick: handleConfirmClick
  }, confirmBtnText ? confirmBtnText : '确认')), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _util.classNames)([bem('columns'), 'scroll-area']),
    ref: function ref(el) {
      return columnsEl = el;
    }
  }, _columns.map(function (column, index) {
    return column.length ? /*#__PURE__*/_react.default.createElement(_pickerColumn.default, {
      column: column,
      columnValue: columnsValue[index] != undefined ? columnsValue[index] : '',
      columnIndex: index,
      itemHeight: _itemHeight,
      baseOffset: baseOffset,
      timeStamp: _timeStamp,
      onChange: handleColumnChange,
      key: index
    }) : '';
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: bem('columns-mask')
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: bem('columns-hairline')
  }))));
});
(0, _util.setDefaultProps)(Picker, {
  columns: {
    type: _propTypes.default.array
  },
  columnsValue: {
    type: _propTypes.default.array
  },
  // 可见的选项个数
  visibleItemCount: {
    type: _propTypes.default.number,
    default: 6
  },
  // 取消按钮文字
  cancelBtnText: {
    type: _propTypes.default.node
  },
  // 确认按钮文字
  confirmBtnText: {
    type: _propTypes.default.node
  },
  // 选项改变时触发
  onChange: {
    type: _propTypes.default.func,
    default: function _default() {}
  },
  // 点击完成按钮时触发
  onConfirm: {
    type: _propTypes.default.func,
    default: function _default() {}
  },
  // 点击取消按钮时触发
  onCancel: {
    type: _propTypes.default.func,
    default: function _default() {}
  }
});

var _default2 = /*#__PURE__*/(0, _react.memo)(PickerPortal);

exports.default = _default2;